--Solitaire
--By DanTheLegoMan Feb 2002
--Version 1.2

--Change history

--Version 1.2
--Fixed a bug in the save/load statistics that meant the bestTime was not saved properly
--Added save/load game capability
--Tweaked the graphics for the Diamonds

--Version 1.1
--New graphics featuring some insect images for the J,Q,K cards taken from iconshock.com
--Launching the application takes you to the menu first
--Statistics are recorded to file (wins,loses, and best time)

--Version 1.0
--First release

--initialization
screen.orientation(1);
t = os.date('*t')
math.randomseed(os.time(t));
math.random(1);

cards = {{value=1 ,suit=1,img=image.load("1h.png") ,used=false},
		 {value=2 ,suit=1,img=image.load("2h.png") ,used=false},
		 {value=3 ,suit=1,img=image.load("3h.png") ,used=false},
		 {value=4 ,suit=1,img=image.load("4h.png") ,used=false},
		 {value=5 ,suit=1,img=image.load("5h.png") ,used=false},
		 {value=6 ,suit=1,img=image.load("6h.png") ,used=false},
		 {value=7 ,suit=1,img=image.load("7h.png") ,used=false},
		 {value=8 ,suit=1,img=image.load("8h.png") ,used=false},
		 {value=9 ,suit=1,img=image.load("9h.png") ,used=false},
		 {value=10,suit=1,img=image.load("10h.png"),used=false},
 		 {value=11,suit=1,img=image.load("11h.png"),used=false},
		 {value=12,suit=1,img=image.load("12h.png"),used=false},
		 {value=13,suit=1,img=image.load("13h.png"),used=false},
		 {value=1 ,suit=2,img=image.load("1c.png") ,used=false},
		 {value=2 ,suit=2,img=image.load("2c.png") ,used=false},
		 {value=3 ,suit=2,img=image.load("3c.png") ,used=false},
		 {value=4 ,suit=2,img=image.load("4c.png") ,used=false},
		 {value=5 ,suit=2,img=image.load("5c.png") ,used=false},
		 {value=6 ,suit=2,img=image.load("6c.png") ,used=false},
		 {value=7 ,suit=2,img=image.load("7c.png") ,used=false},
		 {value=8 ,suit=2,img=image.load("8c.png") ,used=false},
		 {value=9 ,suit=2,img=image.load("9c.png") ,used=false},
		 {value=10,suit=2,img=image.load("10c.png"),used=false},
 		 {value=11,suit=2,img=image.load("11c.png"),used=false},
		 {value=12,suit=2,img=image.load("12c.png"),used=false},
		 {value=13,suit=2,img=image.load("13c.png"),used=false},
		 {value=1 ,suit=3,img=image.load("1d.png") ,used=false},
		 {value=2 ,suit=3,img=image.load("2d.png") ,used=false},
		 {value=3 ,suit=3,img=image.load("3d.png") ,used=false},
		 {value=4 ,suit=3,img=image.load("4d.png") ,used=false},
		 {value=5 ,suit=3,img=image.load("5d.png") ,used=false},
		 {value=6 ,suit=3,img=image.load("6d.png") ,used=false},
		 {value=7 ,suit=3,img=image.load("7d.png") ,used=false},
		 {value=8 ,suit=3,img=image.load("8d.png") ,used=false},
		 {value=9 ,suit=3,img=image.load("9d.png") ,used=false},
		 {value=10,suit=3,img=image.load("10d.png"),used=false},
 		 {value=11,suit=3,img=image.load("11d.png"),used=false},
		 {value=12,suit=3,img=image.load("12d.png"),used=false},
		 {value=13,suit=3,img=image.load("13d.png"),used=false},
		 {value=1 ,suit=4,img=image.load("1s.png") ,used=false},
		 {value=2 ,suit=4,img=image.load("2s.png") ,used=false},
		 {value=3 ,suit=4,img=image.load("3s.png") ,used=false},
		 {value=4 ,suit=4,img=image.load("4s.png") ,used=false},
		 {value=5 ,suit=4,img=image.load("5s.png") ,used=false},
		 {value=6 ,suit=4,img=image.load("6s.png") ,used=false},
		 {value=7 ,suit=4,img=image.load("7s.png") ,used=false},
		 {value=8 ,suit=4,img=image.load("8s.png") ,used=false},
		 {value=9 ,suit=4,img=image.load("9s.png") ,used=false},
		 {value=10,suit=4,img=image.load("10s.png"),used=false},
 		 {value=11,suit=4,img=image.load("11s.png"),used=false},
		 {value=12,suit=4,img=image.load("12s.png"),used=false},
		 {value=13,suit=4,img=image.load("13s.png"),used=false} }

backImg = image.load("back.png");
emptyImg = image.load("emptyDeck.png");

sheight = screen.height()
swidth= screen.width()
green = color.new(0,100,0)
white = color.new(255,255,255)
black = color.new(0,0,0)
cardWidth = 32;
cardHeight = 50;

-- draggingFrom can be a stack index (1 to 7) or 8 for player's cards
draggingFrom = 0;
dragX = 0;
dragY = 0;
dragXOffset = 0;
dragYOffset = 0;
dragCards = {};
playerCards = {};
deckCards = {};
usedCards = {};
quit = false;
home = { 0, 0, 0, 0 }
stacks = { {}, {}, {}, {}, {}, {}, {} }
visible = { 1, 1, 1, 1, 1, 1, 1 }
hidden =  { 0, 1, 2, 3, 4, 5, 6 }
dealt = 0;
win = 0;
lose = 0;
mainMenu = 1;
pauseMenu = 0;
startTime = 0;
endTime = 0;
possibleMoves = 0;
nomovesmessage = 0;
turns = 0
visibleGap = 17;

--get stats
wins = 0
loses = 0
bestTime = 99999999
fStats = io.open("stats.lua")
if (fStats ~= nil) then
	input = fStats:read("*l")
	if (input ~= nil) then
		wins = tonumber(input)
	end
	input = fStats:read("*l")
	if (input ~= nil) then
		loses = tonumber(input)
	end
	input = fStats:read("*l")
	if (input ~= nil) then
		bestTime = tonumber(input)
	end
	fStats:close()
end

function saveStats()
	fStats = io.open("stats.lua","w")
	if (fStats ~= nil) then
		fStats:write(wins,"\n")
		fStats:write(loses,"\n")
		fStats:write(bestTime,"\n")
		fStats:close()
	end
end

function isSaveGame()
	valid = false
	fSave = io.open("save.lua")
	if (fSave ~= nil) then
		input = fSave:read("*l")
		if (input ~= nil) and (string.find(input, "Solitaire Save Game") ~= nil) then
			valid = true
		end
		fSave:close()
	end
	return valid
end

function saveGame()
	fSave = io.open("save.lua","w")
	if (fSave ~= nil) then
		fSave:write("Solitaire Save Game\n")
		--Home Piles
		fSave:write(table.concat(home," "),"\n")
		--Stacks
		for i = 1, 7 do
			fSave:write(hidden[i]," ",visible[i]," ",table.concat(stacks[i]," "),"\n")
		end
		--Player Cards
		fSave:write(table.concat(playerCards," "),"\n")
		--Used Cards
		fSave:write(table.concat(usedCards," "),"\n")
		--Deck cards
		fSave:write(table.concat(deckCards," "),"\n")
		--Number of turns
		fSave:write(turns,"\n")
		--Time taken so far
		fSave:write((os.time() - startTime),"\n")
		fSave:close()
	end
end

function loadGame()
	valid = false
	fSave = io.open("save.lua")
	if (fSave ~= nil) then
		input = fSave:read("*l")
		if (input ~= nil) and (string.find(input, "Solitaire Save Game") ~= nil) then
			valid = true

			--reset variables
			for i = 1, 4 do
				home[i] = 0
			end
			for i = 1, 7 do
				visible[i] = 0
				hidden[i] = 0
			end
			win = 0;
			lose = 0;
			mainMenu = 0;
			pauseMenu = 0;
			turns = 0;
			stacks = { {}, {}, {}, {}, {}, {}, {} }
			playerCards = {};
			deckCards = {};
			usedCards = {};
			dragCards = {};
			possibleMoves = 1;	-- NOTE This is intentionaly set to 1!
			nomovesmessage = 0;

			--Read in home piles
			input = fSave:read("*l")
			if (input ~= nil) then
				index = 1
				for number in string.gmatch(input,"%d+") do
					home[index] = tonumber(number);
					index = index + 1;
				end
				if (index ~= 5) then valid = false end
			else
				valid = false
			end

			--Read in stacks
			for i = 1, 7 do
				input = fSave:read("*l")
				if (input ~= nil) then
					index = -1
					for number in string.gmatch(input,"%d+") do
						if (index == -1) then
							hidden[i] = tonumber(number)
						elseif (index == 0) then
							visible[i] = tonumber(number)
						else
							stacks[i][index] = tonumber(number)
						end
						index = index + 1
					end
				else
					valid = false
					break;
				end
			end
						
			--Read in Player Cards
			input = fSave:read("*l")
			if (input ~= nil) then
				index = 1
				for number in string.gmatch(input,"%d+") do
					playerCards[index] = tonumber(number)
					index = index + 1
				end
			else
				valid = false
			end

			--Read in Used Cards
			input = fSave:read("*l")
			if (input ~= nil) then
				index = 1
				for number in string.gmatch(input,"%d+") do
					usedCards[index] = tonumber(number)
					index = index + 1
				end
			else
				valid = false
			end
			
			--Read in Deck Cards
			input = fSave:read("*l")
			if (input ~= nil) then
				index = 1
				for number in string.gmatch(input,"%d+") do
					deckCards[index] = tonumber(number)
					index = index + 1
				end
			else
				valid = false
			end
						
			--Read in turns taken
			input = fSave:read("*l")
			if (input ~= nil) then
				turns = tonumber(input)
			end
			
			--Read in time taken so far
			timeTakenSoFar = 0
			input = fSave:read("*l")
			if (input ~= nil) then
				timeTakenSoFar = tonumber(input)
			end
			
			startTime = os.time() - timeTakenSoFar;
		end
		fSave:close()
	end
	
	--Delete the save file now
	fSave = io.open("save.lua","w")
	if (fSave ~= nil) then
		fSave:write("\n")
		fSave:close()
	end
		
	if (valid == false) then
		--Bad save game file!
		deal();
	end
end

function getRandomCard()
	index = math.random(52-dealt)
	count = 1
	for i = 1, 52 do
		if (cards[i].used == false) then
			if (index == count) then
				cards[i].used = true;
				dealt = dealt + 1;
				return i;
			else
				count = count + 1
			end
		end
	end
	return -1;
end

function deal()
	--reset home cards
	for i = 1, 4 do
		home[i] = 0
	end
	--reset stack totals
	for i = 1, 7 do
		visible[i] = 0
		hidden[i] = 0
	end
	--reset cards
	win = 0;
	lose = 0;
	mainMenu = 0;
	pauseMenu = 0;
	turns = 0;
	dealt = 0;
	for i = 1, 52 do
		cards[i].used = false
	end

	--Deal the cards in the play area
	stacks = { {}, {}, {}, {}, {}, {}, {} }
	for i = 1, 7 do
		for j = 1, i do
			stacks[i][j] = getRandomCard();
		end
	end
	
	playerCards = {};
	deckCards = {};
	usedCards = {};
	dragCards = {};
	
	for row = 1, 7 do
		for column = row, 7 do
			if (column == row) then
				visible[column] = 1
			else
				hidden[column] = hidden[column] + 1
			end
			drawScreen()
		end
	end
	
	--Deal the player's cards
	for i = 1, 3 do
		playerCards[i] = getRandomCard();
		drawScreen();
	end
	count = 52 - dealt;
	for i = 1, count do
		deckCards[i] = getRandomCard()
	end
	possibleMoves = 0;
	nomovesmessage = 0;
	checkForPossibleMoves()
	startTime = os.time();
end

function drawScreen()
	screen.fillrect(0,0,swidth,sheight,green);
	
	if ((win + lose + mainMenu + pauseMenu) == 0) then
		--Home
		for i = 1, 4 do
			if (home[i] == 0) then
				emptyImg:draw(22 + ((i-1) * 52), 10);
			else
				cards[home[i]].img:draw(22 + ((i-1) * 52), 10);
			end
		end
		--Game
		for i = 1, 7 do
			x = 2 + ((i-1)*34);
			if (hidden[i] > 0) then
				for j = 1, hidden[i] do
					backImg:draw(x, 75 + ((j-1) * 4))
				end
			end
			if (visible[i] > 0) then
				for k = 1, visible[i] do
					cards[stacks[i][hidden[i]+k]].img:draw(x, 75 + (hidden[i] * 4) + ((k-1) * visibleGap))
				end
			end
			if ((hidden[i] + visible[i]) == 0) then
				emptyImg:draw(x,75);
			end
		end
		--Deck
		if (#deckCards > 0) then
			backImg:draw(10, 345);
		else
			emptyImg:draw(10,345);
		end
		--Player's Cards
		if (#playerCards > 0) then
			for i = 1, #playerCards do
				cards[playerCards[i]].img:draw(55 + ((i-1) * 16), 345);
			end
		elseif (draggingFrom == 8) and (#usedCards > 0) then
				--draw the top used card
				cards[usedCards[#usedCards]].img:draw(55,345);
		end
		
		if (draggingFrom > 0) then
			for i = 1, #dragCards do
				cards[dragCards[i]].img:draw(dragX-dragXOffset,dragY-dragYOffset+((i-1)*visibleGap));
			end
		end
	else
		ots = text.size(18)
		otc = text.color(white);

		--Draw the Aces in the corners
		cards[1].img:draw(5,5);
		cards[14].img:draw(swidth-cardWidth-5,5)
		cards[27].img:draw(5,sheight-cardHeight-5)
		cards[40].img:draw(swidth-cardWidth-5,sheight-cardHeight-5)
		if (win == 1) then
			--NOTE Should really use os.difftime - but that doesn't appear to work on the Zen X-Fi 2
			timeTaken = endTime - startTime
			if (timeTaken == bestTime) then
				text.draw(0,70,"Best Time!","center",240)
			else
				text.draw(0,70,"Winner!","center",240)
			end
			text.draw(0,100,"Time : "..timeTaken.." seconds","center",240)
		elseif (lose == 1) then
			if (nomovesmessage == 1) then
				text.draw(0,120,"No Moves Left!","center",240)
			end
		elseif (mainMenu == 1) then
			if (isSaveGame()) then
				-- Add 'Load Game' Button
				screen.fillrect(50,100,140,30,white)
				screen.fillrect(52,102,136,26,green)
				text.draw(50,105,"Load Game","center",190)
			end
		elseif (pauseMenu == 1) then
			-- Add 'Return', 'Save And Quit'
			screen.fillrect(50,50,140,30,white)
			screen.fillrect(52,52,136,26,green)
			text.draw(50,55,"Return","center",190)
			screen.fillrect(50,100,140,30,white)
			screen.fillrect(52,102,136,26,green)
			text.draw(50,105,"Save And Quit","center",190)
		end
	
		--Draw 'New Game' and 'Quit' buttons
		screen.fillrect(50,150,140,30,white)
		screen.fillrect(52,152,136,26,green)
		screen.fillrect(50,200,140,30,white)
		screen.fillrect(52,202,136,26,green)
		text.draw(50,155,"New Game","center",190)
		text.draw(50,205,"Quit","center",190);
		
		--Stats
		if (wins ~= 0) or (loses ~= 0) then
			text.size(14)
			text.draw(0,250,"Total Wins "..wins,"center",240)
			text.draw(0,270,"Total Loses "..loses,"center",240)
			if (wins ~= 0) then
				text.draw(0,290,"Best Time "..bestTime.." seconds","center",240)
			end
		end
		
		--Credits and Version
		text.size(12);
		text.draw(0,360,"Version 1.2","center",240);
		text.draw(0,380,"By DanTheLegoMan","center",240);
		
		text.size(ots)
		text.color(otc);
	end

	screen.update()
end

function checkForWin()
	if (home[1] ~= 0) and (cards[home[1]].value == 13) and
	   (home[2] ~= 0) and (cards[home[2]].value == 13) and
	   (home[3] ~= 0) and (cards[home[3]].value == 13) and
	   (home[4] ~= 0) and (cards[home[4]].value == 13) then
		win = 1;
		endTime = os.time();
		if ((endTime - startTime) < bestTime) then
			bestTime = endTime - startTime
		end
		wins = wins + 1
		saveStats()
	end
end

function checkDrag(x,y)
	--Check the stacks
	if (y >= 75) then
		for i = 1, 7 do
			if (visible[i] > 0) then
				--get boundaries of visible cards
				stackX = 2 + ((i-1)*34);
				stackY = 75 + (hidden[i] * 4);
				stackHeight = ((visible[i]-1)*visibleGap) + cardHeight;
				if (x >= stackX) and (x <= (stackX + cardWidth)) and (y >= stackY) and (y <= (stackY + stackHeight)) then
					y = y - stackY
					--get index of card being dragged
					index = hidden[i] + math.floor(y / visibleGap) + 1
					if (index > #stacks[i]) then
						index = #stacks[i]
					end
					count = #stacks[i] - index + 1
					for j = 1, count do
						table.insert(dragCards,1,table.remove(stacks[i]))
					end
					visible[i] = visible[i] - count;
					draggingFrom = i
					dragXOffset = x - stackX
					dragYOffset = y - (visibleGap*(index-hidden[i]-1))
					return
				end
			end
		end
	end
	
	--Check Player's cards
	if (#playerCards > 0) then
		cardX = 55 + 16*(#playerCards-1);
		cardY = 345;
		if (x >= cardX) and (x <= (cardX + cardWidth)) and (y >= cardY) and (y <= (cardY + cardHeight)) then
			draggingFrom = 8;
			dragCards[1] = table.remove(playerCards);
			dragXOffset = x - cardX
			dragYOffset = y - cardY
		end
	end
end

function returnDraggedCards()
	--return the cards from whence they came
	if (draggingFrom == 8) then
		playerCards[#playerCards+1] = table.remove(dragCards)
	elseif (draggingFrom > 0) and (draggingFrom < 8) then
		count = #dragCards;
		for j = 1, count do
			stacks[draggingFrom][#stacks[draggingFrom]+1] = table.remove(dragCards, 1)
		end
		visible[draggingFrom] = visible[draggingFrom] + count;
	end
end

function checkDragDrop(x,y)
	valid = false;
	
	-- Game stacks
	for i = 1, 7 do
		--Get boundaries of lowest card in stack
		stackX = 2 + ((i-1)*34);
		stackY = 75;
		if (hidden[i] > 1) then
			stackY = stackY + ((hidden[i]-1)*4)
		end
		if (visible[i] > 0) then
			if (hidden[i] > 0) then
				stackY = stackY + 4
			end
			stackY = stackY + ((visible[i]-1)*visibleGap)
		end
		
		if (x >= stackX) and (x <= (stackX + cardWidth)) and (y >= stackY) and (y <= (stackY + 1.5*cardHeight)) then

			--if stack is empty and the top card being dragged is a King, add dragged card(s) to the stack
			if (#stacks[i] == 0) and (cards[dragCards[1]].value == 13) then
				for j = 1, #dragCards do
					stacks[i][j] = dragCards[j];
				end
				visible[i] = visible[i] + #dragCards;
				valid = true
				break;
			end
			
			--if stack is not empty, has a visible card, and the top card being dragged is the opposite suit and one less than
			--the bottom card in the stack, add the dragged card(s) to the stack
			if (#stacks[i] ~= 0) and (visible[i] > 0) and (cards[dragCards[1]].value == (cards[stacks[i][#stacks[i]]].value - 1)) and
				((cards[dragCards[1]].suit % 2) ~= (cards[stacks[i][#stacks[i]]].suit % 2)) then
				for j = 1, #dragCards do
					stacks[i][#stacks[i]+1] = dragCards[j];
				end
				visible[i] = visible[i] + #dragCards
				valid = true
				break;
			end
			
		end
	end
	
	-- Home stacks
	if (valid == false) and (y < 70) and (#dragCards == 1) then
		for i = 1, 4 do
			if (x > (22 + ((i-1) * 52))) and (x < (72 + ((i-1) * 52))) then
				-- If home is empty and we are dragging an Ace, or
				-- home suit matches and home value is one less than dragged card
				-- then add the card to the home pile
				if ((home[i] == 0) and (cards[dragCards[1]].value == 1)) or
					((home[i] ~= 0) and (cards[dragCards[1]].suit == cards[home[i]].suit) and
					 (cards[dragCards[1]].value == cards[home[i]].value + 1)) then
					home[i] = dragCards[1]
					valid = true
					break
				end
			end
		end
		
		checkForWin()
	end
	
	if (valid == true) then
		if (draggingFrom == 8) and (#playerCards == 0) and (#usedCards > 0) then
			--put a used card back into the playerCards
			playerCards[1] = table.remove(usedCards);
		end
		if (win ~= 1) then
			checkForPossibleMoves()
		end
		turns = turns + 1
	else
		returnDraggedCards()
	end

	dragCards = {};
end

function checkClick(x,y)

	-- Game stacks
	if (y >= 75) then
		for i = 1, 7 do
			--If there is at least one hidden card and no visible cards
			if (hidden[i] > 0) and (visible[i] == 0) then
				--Get boundaries of lowest hidden card
				stackX = 2 + ((i-1)*34);
				stackY = 75;
				if (hidden[i] > 1) then
					stackY = stackY + ((hidden[i]-1)*4)
				end
				--Check if we clicked on it
				if (x >= stackX) and (x <= (stackX + cardWidth)) and (y >= stackY) and (y <= (stackY + cardHeight)) then
					hidden[i] = hidden[i] - 1
					visible[i] = visible[i] + 1
					turns = turns + 1
					checkForPossibleMoves()
					return;
				end
			end
		end
	end
	
	cardX = 10;
	cardY = 345;
	if (x >= cardX) and (x <= (cardX + cardWidth)) and (y >= cardY) and (y <= (cardY + cardHeight)) and 
	   ((#deckCards > 0) or (#usedCards > 0)) then
	
		turns = turns + 1
		
		--Check if there any cards in the deck
		if (#deckCards == 0) then
		
			if (possibleMoves == 0) then
				--oh dear, no way to win now
				lose = 1
				nomovesmessage = 1
				loses = loses + 1
				saveStats()
			end
			
			--put player's card in the used deck
			if (#playerCards > 0) then
				for i = 1, #playerCards do
					usedCards[#usedCards+1] = playerCards[i];
				end
				playerCards = {};
			end
			--put used cards back in the deck
			if (#usedCards > 0) then
				for i = 1, #usedCards do
					table.insert(deckCards,1,usedCards[i])
				end
				usedCards = {};
			end

			--reset possible moves
			possibleMoves = 0
		end
	
		--put the player's cards in the used array
		if (#playerCards > 0) then
			for i = 1, #playerCards do
				usedCards[#usedCards+1] = playerCards[i];
			end
			playerCards = {};
		end
		--deal out new cards for the player from top of deck
		count = math.min(#deckCards,3);
		for i = 1, count do
			playerCards[i] = table.remove(deckCards);
		end
		
		checkForPossibleMoves()
	end
end

function checkForPossibleMoves()
	--close to the end, check if there are possible moves after each event
	if (#deckCards == 0) and (#usedCards == 0) then
		possibleMoves = 0
	end
		
	if (possibleMoves == 1) then
		return
	end
	
	--Do any of the stacks have 0 visible and more than 0 hidden
	for i = 1, 7 do
		if (visible[i] == 0) and (hidden[i] > 0) then
			--Stack with an available hidden card
			possibleMoves = 1;
			return;
		end
	end
		
	--Check player cards for moves
	if (#playerCards > 0) then
	
		topCard = playerCards[#playerCards]
		
		--Can top Player Card go to any of the home piles?
		for i = 1, 4 do
			-- If home is empty and we are dragging an Ace, or
			-- home suit matches and home value is one less than dragged card
			-- then add the card to the home pile
			if ((home[i] == 0) and (cards[topCard].value == 1)) or
				((home[i] ~= 0) and (cards[topCard].suit == cards[home[i]].suit) and
				 (cards[topCard].value == cards[home[i]].value + 1)) then
				--Player card can move to home pile i
				possibleMoves = 1;
				return;
			end
		end
		
		--Can top player card go to any of the stacks
		for i = 1, 7 do
			if (#stacks[i] == 0) then
				if (cards[topCard].value == 13) then
					--Player's card (King) can move to empty stack i
					possibleMoves = 1
					return
				end
			elseif (visible[i] > 0) then
				if (cards[topCard].value == (cards[stacks[i][#stacks[i]]].value - 1)) and
				   ((cards[topCard].suit % 2) ~= (cards[stacks[i][#stacks[i]]].suit % 2)) then
					--Player's card can move to stack i
					possibleMoves = 1
					return
				end
			end
		end
	end
	
	--Can any of stacks' bottom cards go to the home pile?
	for i = 1, 7 do
		if (visible[i] > 0) then
			card = stacks[i][#stacks[i]]
			for j = 1, 4 do
				-- If home is empty and we are dragging an Ace, or
				-- home suit matches and home value is one less than dragged card
				-- then add the card to the home pile
				if ((home[j] == 0) and (cards[card].value == 1)) or
					((home[j] ~= 0) and (cards[card].suit == cards[home[j]].suit) and
					 (cards[card].value == cards[home[j]].value + 1)) then
					--Bottom card on stack i can move to home pile j
					possibleMoves = 1;
					return;
				end
			end
		end
	end
	
	--Can any of the cards in a stack move to another stack?
	--NOTE - this is probably only useful if this creates an empty stack or the card now available is either hidden, or can drag to the home pile, right????
	for i = 1, 7 do
		if (visible[i] > 0) then
			for j = hidden[i] + 1, #stacks[i] do
				card = stacks[i][j];
				for k = 1, 7 do
					if (k ~= i) then
						useful = 0
						-- can 'card' drop on stack 'k'?
						if (#stacks[k] == 0) then
							if (cards[card].value == 13) then
								--Can move a King from Stack i to stack k, but we need to determine if this is useful...
								useful = 1
							end
						elseif (visible[k] > 0) then
							if (cards[card].value == (cards[stacks[k][#stacks[k]]].value - 1)) and
							   ((cards[card].suit % 2) ~= (cards[stacks[k][#stacks[k]]].suit % 2)) then
								--Can move card j from stack i to stack k, but we need to determine if this is useful...
								useful = 1
							end
						end
						
						if (useful == 1) then
							--Would this move allow a hidden card to be turned over?
							if (hidden[i] > 0) and (j == hidden[i] + 1) then
								--Useful move, because a hidden card can now be turned over
								possibleMoves = 1
								return
							end
							
							--Would this create an empty stack?
							if (hidden[i] == 0) and (j == 1) and (#stacks[k] ~= 0) then
								--Useful move, because we are creating an empty stack
								possibleMoves = 1
								return
							end
							
							--Would this move allow a card to be moved home?
							if ((j - 1) > hidden[i]) then
								card = stacks[i][j-1]
								for l = 1, 4 do
									if ((home[l] ~= 0) and (cards[card].suit == cards[home[l]].suit) and
										(cards[card].value == cards[home[l]].value + 1)) then
										--Useful move, because the newly revealed card can be sent home
										possibleMoves = 1;
										return;
									end
								end
							end
							
							--Wasn't a useful move!
						end
					end
				end
			end
		end
	end
	
	--No moves found

	--If no more cards left, this means game can't be won
	if (#deckCards == 0) and (#usedCards == 0) then
		lose = 1
		nomovesmessage = 1
		loses = loses + 1
		saveStats()
	end
end

function checkAlmostWon()
	if (win == 0) and (lose == 0) and (#dragCards == 0) and (#deckCards == 0) and (#usedCards == 0) and (#playerCards == 0) then
		for i = 1, 7 do
			if (hidden[i] ~= 0) then
				return
			end
		end
		
		--move all the cards to the home piles
		moved = 1
		while (moved == 1) do
			moved = 0
			for i = 1, 7 do
				if (#stacks[i] > 0) then
					for j = 1, 4 do
						if (home[j] == 0) then
							if (cards[stacks[i][#stacks[i]]].value == 1) then
								home[j] = table.remove(stacks[i])
								visible[i] = visible[i] - 1
								drawScreen()
								moved = 1
								break
							end
						else
							if (cards[stacks[i][#stacks[i]]].value == (cards[home[j]].value + 1)) and
							   (cards[stacks[i][#stacks[i]]].suit == cards[home[j]].suit) then
							   home[j] = table.remove(stacks[i])
							   visible[i] = visible[i] - 1
							   drawScreen()
							   moved = 1
							   break;
							end
						end
					end
				end
			end
		end

		checkForWin()
	end
end

while (1) do
	for i = 0, 6 do
		if control.read()==1 then
			if control.isTouch()==1 then
				x,y = touch.pos()
				if (touch.move() == 1) then
					if (draggingFrom == 0) then
						checkDrag(dragX,dragY);
					else
						dragX = x;
						dragY = y;
					end
				elseif (touch.down() == 1) then
					dragX = x;
					dragY = y;
				elseif (touch.up() == 1) then
					if (draggingFrom > 0) then
						checkDragDrop(x,y);
						draggingFrom = 0;
					end
				elseif (touch.click() == 1) then
					if ((win + lose + mainMenu) > 0) then
						if (x >= 50) and (x <= 190) then
							if (y >= 100) and (y <= 130) and (mainMenu == 1) then
								loadGame()
							elseif (y >= 150) and (y <= 180) then
								deal();
							elseif (y >= 200) and (y <= 230) then
								quit = true;
								break;
							end
						end
					elseif (pauseMenu == 1) then
						if (x >= 50) and (x <= 190) then
							if (y >= 50) and (y <= 80) then
								-- "Return" button
								pauseMenu = 0
							elseif (y >= 100) and (y <= 130) then
								-- "Save and Quit" button
								saveGame()
								quit = true
							elseif (y >= 150) and (y <= 180) then
								-- "New Game" button
								if (turns > 0) then
									-- If player has moved at least one card then this counts as a lose ... mean I know!
									loses = loses + 1
									saveStats()
								end
								deal();
							elseif (y >= 200) and (y <= 230) then
								-- "Quit" button
								if (turns > 0) then
									-- If player has moved at least one card then this counts as a lose ... mean I know!
									loses = loses + 1
									saveStats()
								end
								quit = true;
								break;
							end
						end
					else
						checkClick(x,y);
					end
				end
			elseif control.isButton()==1 then
				if button.click() == 1 then
					if ((mainMenu + win + lose + pauseMenu) > 0) then
						quit = true
					else
						-- Make sure that if a drag operation is in progress we cancel it
						returnDraggedCards()
						dragCards = {};
						draggingFrom = 0;
						pauseMenu = 1;
					end
					break
				end
			end
		end
	end
	if (quit == true) then
		break;
	end
	checkAlmostWon()
	drawScreen();
	screen.backlight(100)
	os.sleep(1)
end

screen.orientation(0);
backImg:close();
emptyImg:close();
for i = 1, 52 do
	cards[i].img:close();
end
--attempt to hide the screen corruption you otherwise get
sheight = screen.height()
swidth= screen.width()
screen.fillrect(0,0,swidth,sheight,black);
screen.update()


